/*
 * Copyright 2008 Red Hat, Inc.
 *
 * This Program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License.
 *
 * This Program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this Program; if not, write to the
 *
 *   Free Software Foundation, Inc.
 *   59 Temple Place, Suite 330
 *   Boston, MA 02111-1307 USA
 *
 */

#ifndef format_h
#define format_h
struct slapi_entry;
struct plugin_state;

struct format_inref_attr {
	char *group, *set, *attribute;
};

void format_free_attr_list(char **attr_list);
char **format_dup_attr_list(char **attr_list);

void format_free_inref_attrs(struct format_inref_attr **);
struct format_inref_attr **format_dup_inref_attrs(struct format_inref_attr **);

void format_free_data(char *data);
char *format_get_data(struct plugin_state *state, struct slapi_entry *e,
		      const char *domain, const char *map,
		      const char *fmt,
		      const char *disallowed_chars,
		      char ***ref_attrs,
		      struct format_inref_attr ***inref_attrs,
		      unsigned int *data_length);
void format_free_data_set(char **data_set, unsigned int *data_lengths);
char **format_get_data_set(struct plugin_state *state, Slapi_Entry *e,
			   const char *domain, const char *map,
			   const char *fmt,
			   const char *disallowed,
			   char ***ref_attrs,
			   struct format_inref_attr ***inref_attrs,
			   unsigned int **data_lengths);

char *format_escape_for_filter(const char *unescaped);
#endif
